//+------------------------------------------------------------------+
//|                                                  JFatlSignal.mqh |
//|                             Copyright  2012,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
#property tester_indicator "ColorJFatl.ex5"
#include <Expert\ExpertSignal.mqh>
//--- wizard description start
//+------------------------------------------------------------------+ 
//|                                                |
//+------------------------------------------------------------------+ 
#define OPEN_LONG     80  //          
#define OPEN_SHORT    80  //          
#define CLOSE_LONG    40  //          
#define CLOSE_SHORT   40  //          
#define REVERSE_LONG  100 //         
#define REVERSE_SHORT 100 //         
#define NO_SIGNAL      0  //         
//+------------------------------------------------------------------+
//| Description of the class                                         |
//| Title=,    ColorJFatl               |
//| Type=SignalAdvanced                                              |
//| Name=JFatl                                                       |
//| Class=CJFatlSignal                                               |
//| Page=                                                            |
//| Parameter=BuyPosOpen,bool,true,           |
//| Parameter=SellPosOpen,bool,true,          |
//| Parameter=BuyPosClose,bool,true,      |
//| Parameter=SellPosClose,bool,true,     |
//| Parameter=Ind_Timeframe,ENUM_TIMEFRAMES,PERIOD_H4,      |
//| Parameter=Length_,uint,5, JMA                  |
//| Parameter=Phase_,int,100, JMA  (-100...100)   |
//| Parameter=IPC,uint,0,  (0...11)                  |           
//| Parameter=SignalBar,uint,1,              |
//+------------------------------------------------------------------+
//--- wizard description end
//+------------------------------------------------------------------+
//|  CJFatlSignal.                                              |
//| :            |
//|  ColorJFatl http://www.mql5.com/en/code/430            |
//|     CExpertSignal.                    |
//+------------------------------------------------------------------+
class CJFatlSignal : public CExpertSignal
  {
protected:
   CiCustom          m_indicator;        //      JFatl

   //---  
   bool              m_BuyPosOpen;       //     
   bool              m_SellPosOpen;      //     
   bool              m_BuyPosClose;      //     
   bool              m_SellPosClose;     //     
   ENUM_TIMEFRAMES   m_Ind_Timeframe;    //   JFatl
   uint              m_Length_;          //  JMA 
   uint              m_Phase_;           //  JMA  (-100...100)
   int               m_IPC;              //   (0...11)
   uint              m_SignalBar;        //      

public:
                     CJFatlSignal();

   //---    
   void              BuyPosOpen(bool value)                  { m_BuyPosOpen=value;       }
   void              SellPosOpen(bool value)                 { m_SellPosOpen=value;      }
   void              BuyPosClose(bool value)                 { m_BuyPosClose=value;      }
   void              SellPosClose(bool value)                { m_SellPosClose=value;     }
   void              Ind_Timeframe(ENUM_TIMEFRAMES value)    { m_Ind_Timeframe=value;    }
   void              Length_(uint value)                     { m_Length_=value;          }
   void              Phase_(int value)                       { m_Phase_=value;           }
   void              IPC(int value)                          { m_IPC=value;              }
   void              SignalBar(uint value)                   { m_SignalBar=value;        }

   //---    
   virtual bool      ValidationSettings();
   //---    
   virtual bool      InitIndicators(CIndicators *indicators); //  
   //---      
   virtual int       LongCondition();
   virtual int       ShortCondition();

   bool              InitJFatl(CIndicators *indicators);   // ,   ColorJFatl

protected:

  };
//+------------------------------------------------------------------+
//|  CJFatlSignal.                                        |
//| INPUT:  .                                                     |
//| OUTPUT: .                                                     |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
void CJFatlSignal::CJFatlSignal()
  {
//---    
   m_BuyPosOpen=true;
   m_SellPosOpen=true;
   m_BuyPosClose=true;
   m_SellPosClose=true;

//---   
   m_Ind_Timeframe=PERIOD_H4;
   m_Length_=5;
   m_Phase_=100;
   m_IPC=0;
//---  
   m_SignalBar=1;
   m_used_series=USE_SERIES_OPEN+USE_SERIES_HIGH+USE_SERIES_LOW+USE_SERIES_CLOSE;
  }
//+------------------------------------------------------------------+
//|   .                                   |
//| INPUT:  .                                                     |
//| OUTPUT: true -   ,  false.           |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
bool CJFatlSignal::ValidationSettings()
  {
//---  
   if(m_IPC>11)
     {
      printf(__FUNCTION__+":  m_IPC      11");
      return(false);
     }

//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|    .                           |
//| INPUT:  indicators -   -               |
//|                        .                    |
//| OUTPUT: true -    ,  false.       |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
bool CJFatlSignal::InitIndicators(CIndicators *indicators)
  {
//---  
   if(indicators==NULL) return(false);

//---   
   if(!InitJFatl(indicators)) return(false);

//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   ColorJFatl.                             |
//| INPUT:  indicators -   -               |
//|                        .                    |
//| OUTPUT: true -    ,  false.       |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
bool CJFatlSignal::InitJFatl(CIndicators *indicators)
  {
//---  
   if(indicators==NULL) return(false);

//---    
   if(!indicators.Add(GetPointer(m_indicator)))
     {
      printf(__FUNCTION__+":   ");
      return(false);
     }

//---   
   MqlParam parameters[4];
   parameters[0].type=TYPE_STRING;
   parameters[0].string_value="ColorJFatl.ex5";
   parameters[1].type=TYPE_UINT;
   parameters[1].integer_value=m_Length_;
   parameters[2].type=TYPE_INT;
   parameters[2].integer_value=m_Phase_;
   parameters[3].type=TYPE_UINT;
   parameters[3].integer_value=m_IPC;

//---     
   if(!m_indicator.Create(m_symbol.Name(),m_Ind_Timeframe,IND_CUSTOM,4,parameters))
     {
      printf(__FUNCTION__+":   ");
      return(false);
     }
     
//---  
   if(!m_indicator.NumBuffers(2)) return(false);
   
//---     ColorJFatl
   return(true);
  }
//+------------------------------------------------------------------+
//|                              |
//|                            |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CJFatlSignal::LongCondition()
  {
//---       1  ColorJFatl
   double Signal0=m_indicator.GetData(1,m_SignalBar);
   double Signal1=m_indicator.GetData(1,m_SignalBar+1);

//---    
   if(Signal0==1)
     {
      if(Signal1==2 && m_BuyPosOpen)
        {
         if(m_SellPosClose) return(REVERSE_SHORT);
         else return(OPEN_LONG);
        }

      if(m_SellPosClose) return(CLOSE_SHORT);
     }
//---   
   return(NO_SIGNAL);
  }
//+------------------------------------------------------------------+
//|                              |
//|                            |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CJFatlSignal::ShortCondition()
  {
//---       1  ColorJFatl
   double Signal0=m_indicator.GetData(1,m_SignalBar);
   double Signal1=m_indicator.GetData(1,m_SignalBar+1);

//---    
   if(Signal0==2)
     {
      if(Signal1==1 && m_SellPosOpen)
        {
         if(m_BuyPosClose) return(REVERSE_LONG);
         else return(OPEN_SHORT);
        }

      if(m_BuyPosClose) return(CLOSE_LONG);
     }
//---      
   return(NO_SIGNAL);
  }
//+------------------------------------------------------------------+